// -- mikes cci trend system

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Orange



//---- input parameters
extern int HistoryMax= 5000;
extern int pipsdiff= 5;
//---- buffers


double BufferBuySignals[];
double BufferSellSignals[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //---- indicator line
   IndicatorBuffers(2);

   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,BufferBuySignals);
   SetIndexArrow(0,140); //238
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,BufferSellSignals);
   SetIndexArrow(1,140); //238
   //----
   return(0);
}
  

int start()
{
  
   int i,shift, lastbar, 
        swing_in= 30, // extra 30 bars for swing in
        counted_bars= IndicatorCounted();

   lastbar= MathMin(HistoryMax, Bars-swing_in-1);

   SetIndexDrawBegin(0, Bars-lastbar);   
   SetIndexDrawBegin(1, Bars-lastbar);

   int j;       
  
   for (shift=0;  shift < lastbar+swing_in;  shift++) {
      double ma144 = iMA(Symbol(),Period(),144,0,MODE_EMA,PRICE_CLOSE, shift);
      double lastma144 = iMA(Symbol(),Period(),144,0,MODE_EMA,PRICE_CLOSE, shift+1);
      double threema144 = iMA(Symbol(),Period(),144,0,MODE_EMA,PRICE_CLOSE, shift+3);
      double fivema144 = iMA(Symbol(),Period(),144,0,MODE_EMA,PRICE_CLOSE, shift+5);
      double tenma144 = iMA(Symbol(),Period(),144,0,MODE_EMA,PRICE_CLOSE, shift+10);              


// proven can have a trendline
// now need to set price correct, work out where highs are
// and where they intersect with next , so we need to 
// do something...
              double cciValue ; double oldcciValue;
     if  ((ma144 >=High[shift] )  && (lastma144 <= High[shift+1]) ){//&& (threema144 < Close[shift+3])){// && (fivema144 < Close[shift+5]) && (tenma144 < Close[shift+10])  ){
       BufferSellSignals[shift] = High[shift];       
        cciValue = iCCI(Symbol(), Period(), 14, 0,shift);     
        oldcciValue = iCCI(Symbol(), Period(), 14, 0,shift+5); 
       ObjectCreate("test"+Close[shift],OBJ_TREND, 1, Time[shift+5], oldcciValue, Time[shift], cciValue);
      }
     else
     {
       BufferSellSignals[shift] = 0;           
      }
      
    if  ((ma144 <=Low[shift] )  && (lastma144 >= Low[shift+1]) ){//&& (threema144 < Close[shift+3])){// && (fivema144 < Close[shift+5]) && (tenma144 < Close[shift+10])  ){
       BufferBuySignals[shift] = Low[shift];   
        cciValue = iCCI(Symbol(), Period(), 14, 0,shift);     
        oldcciValue = iCCI(Symbol(), Period(), 14, 0,shift+5); 
       ObjectCreate("test"+Close[shift],OBJ_TREND, 1, Time[shift+5], oldcciValue, Time[shift], cciValue);
      }
     else
     {
       BufferBuySignals[shift] = 0;           
      }
     
             
  //   if  ((ma144 <=pricenow )  && (lastma144 > Close[shift+1]) && (threema144 > Close[shift+3]) && (fivema144 > Close[shift+5]) && (tenma144 > Close[shift+10])  ){
    //   BufferBuySignals[shift] = ma144;    
     // }
     //else
    // {
     //  BufferBuySignals[shift] = 0;
      
    //  }
      
   }
   return(0);
}


