#include <WinUser32.mqh>
#property copyright "Copyright  2005, timotei"
#property link      "no link"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 Red
//=====================================================================================================
extern int       BoxSize=5;
extern int       Reverse=2;
extern int       BarsCount=50;
extern int       XOSymbol=158;
//=====================================================================================================
double X1[];
double X2[];
double X3[];
double X4[];
double O1[];
double O2[];
double O3[];
double O4[];

/*
double tX1;
double tX2;
double tX3;
double tX4;
double tO1;
double tO2;
double tO3;
double tO4;*/
//=====================================================================================================
datetime prevtime=0;

double Step=0.0;
double Cur=0.0;
double RndCur=0.0;
double LastBox=0.0;

int LastBoxNo=0;
int BoxCurNo=0;
int BarCnt=0;

bool XO=false;
bool startflag=true;
//=====================================================================================================
int init()
{
   IndicatorBuffers(8);

   if(
   !SetIndexBuffer(0,X1) &&
   !SetIndexBuffer(1,X2) &&
   !SetIndexBuffer(2,X3) &&
   !SetIndexBuffer(3,X4) &&
   !SetIndexBuffer(4,O1) &&
   !SetIndexBuffer(5,O2) &&
   !SetIndexBuffer(6,O3) &&
   !SetIndexBuffer(7,O4))
   Print("cannot set indicator buffers!");

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexStyle(7,DRAW_ARROW);

   SetIndexArrow(0,XOSymbol);
   SetIndexArrow(1,XOSymbol);
   SetIndexArrow(2,XOSymbol);
   SetIndexArrow(3,XOSymbol);
   SetIndexArrow(4,XOSymbol);
   SetIndexArrow(5,XOSymbol);
   SetIndexArrow(6,XOSymbol);
   SetIndexArrow(7,XOSymbol);

   SetIndexLabel(0,"X1");
   SetIndexLabel(1,"X2");
   SetIndexLabel(2,"X3");
   SetIndexLabel(3,"X4");
   SetIndexLabel(4,"O1");
   SetIndexLabel(5,"O2");
   SetIndexLabel(6,"O3");
   SetIndexLabel(7,"O4");

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   SetIndexEmptyValue(5,0.0);
   SetIndexEmptyValue(6,0.0);
   SetIndexEmptyValue(7,0.0);
   
  	Step = (BoxSize)*Point;
	LastBoxNo=MathFloor(Close[0]/Step);
	LastBox	= LastBoxNo*Step;
   prevtime = Time[0];
  	
	if (Bars<BarsCount) BarCnt=Bars; else BarCnt=BarsCount;
   return(0);
}
//=====================================================================================================
int deinit()
{	return(0);	}
//=====================================================================================================
void ShiftR()                             //    
{   
   int i=0;
   int n;
   while(i!=BarCnt)
	{
      n=i+1;
		X1[i]=X1[n];		O1[i]=O1[n];
		X2[i]=X2[n];		O2[i]=O2[n];
		X3[i]=X3[n];		O3[i]=O3[n];
		X4[i]=X4[n];		O4[i]=O4[n];
      i++;
	}
}
//=====================================================================================================
void ShiftL()                             //     
{   
   int i=BarCnt;
   int n;
   while(i!=0)
	{
      n=i-1;
		X1[i]=X1[n];		O1[i]=O1[n];
		X2[i]=X2[n];		O2[i]=O2[n];
		X3[i]=X3[n];		O3[i]=O3[n];
		X4[i]=X4[n];		O4[i]=O4[n];
	   i--;
	}
	X1[0]=0;		O1[0]=0;
	X2[0]=0;		O2[0]=0;
	X3[0]=0;		O3[0]=0;
	X4[0]=0;		O4[0]=0;
}
//=====================================================================================================
bool NewBar()                             //    
{   
	if(prevtime != Time[0]) 
	{          
      prevtime = Time[0];							//  
      return(true);
   }
}
//=====================================================================================================
double GetCurPrice()
{
	return(Close[0]);
}
//=====================================================================================================
void SwitchXO()
{
   ShiftL();
	XO=!XO;
}
//=====================================================================================================
void AddX(bool Rev)
{
	if (Rev)	{SwitchXO();}
	
   while(LastBoxNo<=BoxCurNo)
	{
   	LastBoxNo++;
		LastBox=(LastBoxNo*Step);
		if (X1[0]!=0.0 && X2[0]!=0.0 && X3[0]!=0.0 && X4[0]!=0.0) {ShiftL();}

		if			(X1[0]==0.0) 	X1[0]=LastBox;
		else if	(X2[0]==0.0) 	X2[0]=LastBox;
		else if	(X3[0]==0.0) 	X3[0]=LastBox;
		else if	(X4[0]==0.0) 	X4[0]=LastBox;
   	if (LastBoxNo==BoxCurNo) break;
	}
}
//=====================================================================================================
void AddO(bool Rev)
{
	if (Rev)	{SwitchXO();}
	
   while(LastBoxNo>=BoxCurNo)
	{
   	LastBoxNo--;
		LastBox=(LastBoxNo*Step);
		if (O1[0]!=0.0 && O2[0]!=0.0 && O3[0]!=0.0 && O4[0]!=0.0) {ShiftL();}

		if			(O1[0]==0.0) 	O1[0]=LastBox;
		else if	(O2[0]==0.0) 	O2[0]=LastBox;
		else if	(O3[0]==0.0) 	O3[0]=LastBox;
		else if	(O4[0]==0.0) 	O4[0]=LastBox;
   	if (LastBoxNo==BoxCurNo) break;
	}
}
//=====================================================================================================
void CheckBox()
{
	if (!XO)// OOOOOOOOOOOOO
	{
		if       (BoxCurNo-LastBoxNo >= Reverse)	AddX(true);
		else if  (BoxCurNo<LastBoxNo)	      	   AddO(false);
	}
	else
	if (XO) // XXXXXXXXXXXXX
	{
		if        (LastBoxNo-BoxCurNo >= Reverse)	AddO(true);
		else if   (BoxCurNo>LastBoxNo)   			AddX(false);
	}
}
//=====================================================================================================
int start()
{
   if (startflag) {O1[0]=LastBox;startflag=false;}
   if(NewBar())   ShiftR();										//       
	Cur=GetCurPrice();
	RndCur	= MathFloor(Cur/Step)*Step;
	BoxCurNo	= MathFloor(Cur/Step);
	LastBox	= LastBoxNo*Step;
	CheckBox();  
	return(0);
}
//=====================================================================================================


