//+------------------------------------------------------------------+
//|                                               EA_NonLagma_v5.mq4 |
//|                                            	 lucidlamp@gmail.com |
//+------------------------------------------------------------------+

#property link "lucidlamp@gmail.com"

extern double Risk=1000; // The lower the number the higher the risk...
extern int Price=0;
extern int Length=8;
extern int Displace=0;
extern int Filter=3;
extern int Color=1;
extern int ColorBarBack=1;
extern double Deviation=0;   

// perhaps for optimization?

extern double SL=0;
extern double TP=0;      

// 

double Lots;
double dTemp;

int iTicket=0;
int iTemp;

int init()
  {
  }

int deinit()
  {
  }

int start()
	{
		iTemp=iCustom(NULL,0,"NonLagMA_v5",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,3,1);
		if(iTicket==0 && iTemp==1)
			{
				Lots=dLots();
				iTicket=OrderSend(Symbol(),OP_BUY,Lots,dAsk(),1,SL,TP,sComment(),0,0,CLR_NONE);
			}
		else if(iTicket==0 && iTemp==(-1))
			{
				Lots=dLots();
				iTicket=OrderSend(Symbol(),OP_SELL,Lots,dBid(),1,SL,TP,sComment(),0,0,CLR_NONE);
			}
		else if(iTicket>0 && iTemp==1 && !bOrderType())
			{
				OrderClose(iTicket,Lots,dAsk(),1,CLR_NONE);
				Lots=dLots();
				iTicket=OrderSend(Symbol(),OP_BUY,dLots(),dAsk(),1,SL,TP,sComment(),0,0,CLR_NONE);
			}
		else if(iTicket>0 && iTemp==(-1) && bOrderType())
			{
				OrderClose(iTicket,Lots,dBid(),1,CLR_NONE);
				Lots=dLots();
				iTicket=OrderSend(Symbol(),OP_SELL,dLots(),dBid(),1,SL,TP,sComment(),0,0,CLR_NONE);
			}
		else
			{
			}
  }

string sComment()
	{
		return("EA_NonLagma_v5 " + Symbol()+ " " + Period());
	}

bool bOrderType()
	{
		int iOrdersTotal=OrdersTotal();
		for(int x=iOrdersTotal-1;x>=0;x--)
			{
				OrderSelect(x,SELECT_BY_POS);
				if(OrderSymbol()==Symbol() && OrderComment()==sComment())
					{
						if(OrderType()==OP_BUY)
							{
								return(true);
							}
					}
			}
		return(false);
	}
	
double dLots()
	{
		dTemp=AccountFreeMargin();
		dTemp/=Risk;
		dTemp=NormalizeDouble(dTemp,1);
		if(dTemp<dMinLot())
			{
				dTemp=dMinLot();
			}
		if(dTemp>dMaxLot())
			{
				dTemp=dMaxLot();
			}
		return(dTemp);
	}

double dAsk()
	{
		return(MarketInfo(Symbol(),MODE_ASK));
	}
	
double dBid()
	{
		return(MarketInfo(Symbol(),MODE_BID));
	}

double dMinLot()
	{
		return(MarketInfo(Symbol(),MODE_MINLOT));
	}

double dMaxLot()
	{
		return(MarketInfo(Symbol(),MODE_MAXLOT));
	}

