//+------------------------------------------------------------------+
//|                                                      Osc Ema.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Oscillateur EMA.mq4 |
//| Copyright  2009, MetaQuotes Software Corp. |
//| MetaTrader 4, MetaTrader 5, TeamWox / MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//----

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
int counted_bars=IndicatorCounted();
//MM courte 10
double ma10 = iMA(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, 0);
double ma5 = iMA(NULL, 0, 10, 0, MODE_EMA, ma10, 0);

double diff=ma10-ma5;
double indic=ma10+diff;


//MM longue 25
double ma10L = iMA(NULL, 0, 25, 0, MODE_EMA, PRICE_CLOSE, 0);
double ma5L = iMA(NULL, 0, 25, 0, MODE_EMA, ma10L, 0);

double diffL=ma10L-ma5L;
double indicL=ma10L+diffL;

double OscillateurMM=indic-indicL;


Comment(OscillateurMM);

return(0);
}
//+------------------------------------------------------------------+ -+